From f8e89f60b82e0478b40a2fab836a26f8abc685a0 Mon Sep 17 00:00:00 2001
From: Hannes Domani <ssbssa@yahoo.de>
Date: Mon, 26 Jan 2009 19:33:42 +0100
Subject: [PATCH] fix h264 encoding in windows

---
 configure.ac                                     |    1 +
 extras/contrib/src/Makefile                      |    1 +
 extras/contrib/src/Patches/pthreads-detach.patch |   12 ++++++++++++
 modules/codec/x264.c                             |    1 +
 4 files changed, 15 insertions(+), 0 deletions(-)
 create mode 100644 extras/contrib/src/Patches/pthreads-detach.patch

diff --git a/configure.ac b/configure.ac
index 5e93a8f..115b184 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1197,6 +1197,7 @@ elif test "${SYS}" != "mingwce"; then
     VLC_ADD_PLUGIN([msn])
     VLC_ADD_LIBS([dmo],[-lole32 -luuid])
     VLC_ADD_PLUGIN([globalhotkeys])
+    VLC_ADD_CFLAGS([x264],[-DPTW32_STATIC_LIB])
 else
     VLC_ADD_PLUGIN([win32text])
 fi
diff --git a/extras/contrib/src/Makefile b/extras/contrib/src/Makefile
index 7cc7a0c..b52ce35 100644
--- a/extras/contrib/src/Makefile
+++ b/extras/contrib/src/Makefile
@@ -2390,6 +2390,7 @@ pthreads-w32-$(PTHREADS_VERSION)-release.tar.gz:
 
 pthreads: pthreads-w32-$(PTHREADS_VERSION)-release.tar.gz
 	$(EXTRACT_GZ)
+	(cd $@; patch -p0 < ../Patches/pthreads-detach.patch)
 
 .pthreads: pthreads
 	(cd $<; $(HOSTCC) make $(PTHREADSCONF) GC GC-static && mkdir -p $(PREFIX)/include && cp -v pthread.h sched.h semaphore.h $(PREFIX)/include/ && mkdir -p $(PREFIX)/lib && cp -v *.{a,dll} $(PREFIX)/lib/)
diff --git a/extras/contrib/src/Patches/pthreads-detach.patch b/extras/contrib/src/Patches/pthreads-detach.patch
new file mode 100644
index 0000000..73e9f36
--- /dev/null
+++ b/extras/contrib/src/Patches/pthreads-detach.patch
@@ -0,0 +1,12 @@
+--- ptw32_processTerminate.c	Mon Jan 26 18:00:34 2009
++++ ptw32_processTerminate.c	Mon Jan 26 18:00:42 2009
+@@ -96,6 +96,9 @@
+ 	  tp = tpNext;
+ 	}
+ 
++      ptw32_threadReuseTop = PTW32_THREAD_REUSE_EMPTY;
++      ptw32_threadReuseBottom = PTW32_THREAD_REUSE_EMPTY;
++
+       LeaveCriticalSection (&ptw32_thread_reuse_lock);
+ 
+       /* 
diff --git a/modules/codec/x264.c b/modules/codec/x264.c
index 1e5005d..910a9b6 100644
--- a/modules/codec/x264.c
+++ b/modules/codec/x264.c
@@ -35,6 +35,7 @@
 #include <vlc_codec.h>
 
 #ifdef PTW32_STATIC_LIB
+#include <sched.h>
 #include <pthread.h>
 #endif
 #include <x264.h>
-- 
1.5.6.1.1071.g76fb

